public class Dichotomie{
    /**
     * recherche une valeur de manière récursive dans un tableau trié
     * @param tab : le tableau
     * @param v : la valeur
     * @param deb, fin : les deux indices entre lesquel chercher
     * @return l'indice de la première case contenant la valeur ou -1 si elle n'est pas dans le tableau
     */
    
    public static int recherche(Double[] tab, double v, int deb, int fin) {
	if (deb==fin) {
	    if (tab[deb] == v) {
		return deb;
	    } else {
		return -1;
	    }
	}
	int milieu = (deb+fin)/2; //milieu est la partie entière de (deb+fin)/2 
	if (v <= tab[milieu]) {
	    return recherche(tab, v, deb, milieu);
	} else {
	    return recherche(tab, v, (milieu+1), fin);
	}
    }
 
/**
     * recherche une valeur de manière  dans un tableau trié
     * @param tab : le tableau
     * @param v : la valeur
     * @return l'indice de la première case contenant la valeur ou -1 si elle n'est pas dans le tableau
     */
    public static int recherche(Double[] tab, double v) {
	return(recherche(tab,v,0,tab.length-1));
    }


    /**position d'insertion
     */
  public static int insertion(Double[] tab, double v, int deb, int fin) {
	if (deb==fin) {
	    if (tab[deb] >= v) {
		return deb;
	    } else {
		return (deb+1);
	    }
	}
	int milieu = (deb+fin)/2; //milieu est la partie entière de (deb+fin)/2
	if (v <= tab[milieu]) {
	    return insertion(tab, v, deb, milieu);
	} else {
	    return insertion(tab, v, (milieu+1), fin);
	}
    }

    /**tri par insertion
     */
    public static void tri(Double[] tab) {
	int p;
	Double val;
	for (int i = 1; i<tab.length;i++){
	    val = tab[i];
	    p = insertion(tab,val,0,(i-1));
	    for (int k =i; k>p;k--){
		tab[k]=tab[k-1];
	    }
	    tab[p]=val;
	}
    }
}   
